searchNodes=[{"doc":"Top-level module holding the Shun library, which provides URI, IPv4 and IPv6 address verification primitives.SetupThe usual way to use Shun is by installing it in a custom module.defmodule MyApp.Shun do use Shun.Builder handle Shun.Preset.IPv6.Embedded reject Shun.Preset.AWS.InstanceMetadata endAdditional Rules can be added using a simple DSL (provided by Shun.Rule and Shun.Builder):defmodule MyApp.Shun do use Shun.Builder handle Shun.Preset.IPv6.Embedded reject Shun.Preset.AWS.InstanceMetadata reject &quot;10.0.0.0/8&quot; reject %URI{scheme: scheme} when scheme != &quot;https&quot; endSee:Shun.Builder for more information on usage;Shun.Rule for information on the types of Rules you may use; andShun.Rule.Target on how you can express targets.UsageOnce a module has been set up, you can use it with Shun.verify/2 or Shun.verify/3.For example:Shun.verify(MyApp.Shun, &quot;http://google.com&quot;)","ref":"Shun.html","title":"Shun","type":"module"},{"doc":"Performs verification on the value using the provider specifies.Implemented by Shun.Verifier.perform/2.","ref":"Shun.html#verify/3","title":"Shun.verify/3","type":"function"},{"doc":"Represents an IP Address which can be IPv4 or IPv6.","ref":"Shun.html#t:address/0","title":"Shun.address/0","type":"type"},{"doc":"Represents the Target prior to verification.","ref":"Shun.html#t:name/0","title":"Shun.name/0","type":"type"},{"doc":"Represents an URI which points to the Target.","ref":"Shun.html#t:uri/0","title":"Shun.uri/0","type":"type"},{"doc":"Provides convenience functions to deal with IPv4 and IPv6 addresses.","ref":"Shun.Address.html","title":"Shun.Address","type":"module"},{"doc":"","ref":"Shun.Address.html#is_v4/1","title":"Shun.Address.is_v4/1","type":"macro"},{"doc":"","ref":"Shun.Address.html#is_v6/1","title":"Shun.Address.is_v6/1","type":"macro"},{"doc":"","ref":"Shun.Address.html#parse/1","title":"Shun.Address.parse/1","type":"function"},{"doc":"","ref":"Shun.Address.html#to_value/1","title":"Shun.Address.to_value/1","type":"function"},{"doc":"","ref":"Shun.Address.html#t:result_ipv4/0","title":"Shun.Address.result_ipv4/0","type":"type"},{"doc":"","ref":"Shun.Address.html#t:result_ipv4_address/0","title":"Shun.Address.result_ipv4_address/0","type":"type"},{"doc":"","ref":"Shun.Address.html#t:result_ipv4_range/0","title":"Shun.Address.result_ipv4_range/0","type":"type"},{"doc":"","ref":"Shun.Address.html#t:result_ipv6/0","title":"Shun.Address.result_ipv6/0","type":"type"},{"doc":"","ref":"Shun.Address.html#t:result_ipv6_address/0","title":"Shun.Address.result_ipv6_address/0","type":"type"},{"doc":"","ref":"Shun.Address.html#t:result_ipv6_range/0","title":"Shun.Address.result_ipv6_range/0","type":"type"},{"doc":"","ref":"Shun.Address.html#t:value_ipv4/0","title":"Shun.Address.value_ipv4/0","type":"type"},{"doc":"","ref":"Shun.Address.html#t:value_ipv6/0","title":"Shun.Address.value_ipv6/0","type":"type"},{"doc":"Provides a way to programmatically create modules that implement the Shun.Provider behaviour.The Builder is supposed to be used in your own module, by calling use Shun.Builder. This in turn calls the __using__ macro and prepares the module for use with the DSL as defined by Shun.Rule.The accept/1, reject/1 and handle/2 macros generate the relevant Shun.Rule structs, and enqueues them for compilation. On the other hand, Rules already defined in a Preset (any module which implements the Shun.Preset behaviour) can be incorporated with preset/1.Rules are built and accumulated in the :rules module attribute.CompilationBased on the Rules given prior to compilation, the Builder emits implementations for handle_url/1, handle_ipv4/2 and handle_ipv6/2, the latter two called by an emitted implementation of handle_ip/1.Functions are generated in the following order:handle_ip/1 for IPv4, routing to handle_ipv4/2.handle_ip/1 for IPv6, routing to handle_ipv6/2.For each Rule, an implementation of handle_url/1, handle_ipv4/2, or handle_ipv6/2.(Optional) Fallback implementation of handle_url/1.(Optional) Fallback implementation of handle_ipv4/1.(Optional) Fallback implementation of handle_ipv6/1.The Builder also emits fallback clauses for all three types with the following defaults, in case you have not specified the corresponding patterns:URIs are resolved, and their IP addresses are verified (via :resolve).IP addresses that are not IPv4 or IPv6 are rejected (via :reject).IPv4 addresses are rejected (via :reject).IPv6 addresses are rejected (via :reject).You can override this behavior by ensuring that the patterns completely cover each Target type. For example, to implement a Provider that rejects all unknown URIs instead of resolving them (and rejecting their IP addresses by default), implement a fallback clause for URIs:defmodule MyApp.Shun do use Shun.Builder accept %URI{host: host} when host == &quot;example.com&quot; reject %URI{} endYou can also use the fallback clause with a function reference (see handle/2) to implement custom fallback logic:defmodule MyApp.Shun do use Shun.Builder accept %URI{host: host} when host == &quot;example.com&quot; handle %URI{}, &amp;handle_uri/1 def handle_uri(uri) do cond do uri.host == &quot;test.example.com&quot; -&gt; :accept true -&gt; :reject end end endFor example, to implement a Provider that accepts all unknown IP addresses, implement fallback clauses for both IPv4 and IPv6 addresses:defmodule MyApp.Shun do use Shun.Builder … accept {_, _, _, _} accept {_, _, _, _, _, _, _, _} end","ref":"Shun.Builder.html","title":"Shun.Builder","type":"module"},{"doc":"Adds an Accept rule generated with Shun.Rule.accept/1, or Accept rules generated by the preset module provided.","ref":"Shun.Builder.html#accept/1","title":"Shun.Builder.accept/1","type":"macro"},{"doc":"Adds Dynamic rules generated by the preset module provided, with its default handler function used to handle the matched entries.","ref":"Shun.Builder.html#handle/1","title":"Shun.Builder.handle/1","type":"macro"},{"doc":"Adds a Dynamic rule generated with Shun.Rule.handle/2, or Dynamic rules generated by the preset module provided.","ref":"Shun.Builder.html#handle/2","title":"Shun.Builder.handle/2","type":"macro"},{"doc":"Adds an Reject rule generated with Shun.Rule.accept/1, or Reject rules generated by the preset module provided.","ref":"Shun.Builder.html#reject/1","title":"Shun.Builder.reject/1","type":"macro"},{"doc":"Specifies how additional reusable rules are provided.Modules that implement this behaviour can be used with Shun.Builder.accept/1, Shun.Builder.reject/1 or Shun.Builder.handle/2. If modules implement a default handler function then they can be used with Shun.Builder.handle/1 as well.","ref":"Shun.Preset.html","title":"Shun.Preset","type":"behaviour"},{"doc":"Returns a list of Rules (Shun.Rule.t/0) for use in Provider modules at compile-time.Rules can be built by using convenience functions in Shun.Rule.If you need to implement dynamic rules that query external resources, you should use Shun.Builder.handle/2 and pass the function reference.","ref":"Shun.Preset.html#c:rules/1","title":"Shun.Preset.rules/1","type":"callback"},{"doc":"","ref":"Shun.Preset.html#c:rules/2","title":"Shun.Preset.rules/2","type":"callback"},{"doc":"Provides an AWS-related rule which forbids access to the EC2 Instance Metadata endpoint.Rules within this Preset are based on:Instance Metadata and User Data","ref":"Shun.Preset.AWS.InstanceMetadata.html","title":"Shun.Preset.AWS.InstanceMetadata","type":"module"},{"doc":"Provides IPv4 related rules that reject link-local blocks.Rules within this Preset use the following ranges:169.254.0.0/16","ref":"Shun.Preset.IPv4.LinkLocal.html","title":"Shun.Preset.IPv4.LinkLocal","type":"module"},{"doc":"Provides IPv4 related rules that reject loopback blocks.Rules within this Preset use the following ranges:127.0.0.0/8","ref":"Shun.Preset.IPv4.Loopback.html","title":"Shun.Preset.IPv4.Loopback","type":"module"},{"doc":"Provides IPv4 related rules that reject private blocks.Rules within this Preset use the following ranges:10.0.0.0/8172.16.0.0/12192.168.0.0/16","ref":"Shun.Preset.IPv4.Private.html","title":"Shun.Preset.IPv4.Private","type":"module"},{"doc":"Provides IPv6 related rules which verify the embedded IPv4 addresses correctly. Instead of verifying the IPv6 addresses as-is, the embedded IPv4 address will be extracted and verified as if it has been used from the beginning.Rules within this Preset are based on:RFC4291: ::ffff:0:0/96.RFC6052: 64:ff9b::/96.","ref":"Shun.Preset.IPv6.Embedded.html","title":"Shun.Preset.IPv6.Embedded","type":"module"},{"doc":"Convenience function to obtain mapped IPv4 address from an IPv6 address.","ref":"Shun.Preset.IPv6.Embedded.html#handle_boxed/1","title":"Shun.Preset.IPv6.Embedded.handle_boxed/1","type":"function"},{"doc":"Provides IPv6 related rules that reject link-local blocks.Rules within this Preset use the following ranges:fe80::/10","ref":"Shun.Preset.IPv6.LinkLocal.html","title":"Shun.Preset.IPv6.LinkLocal","type":"module"},{"doc":"Provides IPv6 related rules that reject loopback blocks.Rules within this Preset use the following ranges:::1","ref":"Shun.Preset.IPv6.Loopback.html","title":"Shun.Preset.IPv6.Loopback","type":"module"},{"doc":"Specifies how the incoming URI or IP Address should be validated.This Behaviour is automatically implemented by modules using Shun.Builder (directly, or via use Shun.Builder).","ref":"Shun.Provider.html","title":"Shun.Provider","type":"behaviour"},{"doc":"Provides decision on the IPv4 or IPv6 address.For each incoming IP Address, or for URIs that have previously been marked as :resolve and since have been resolved to IP addresses, the following values are accepted: :accept: the IP Address is is accepted for use. No further verification is required. Verification will halt with typed result {:ok, nonempty_list(Shun.address())}. :reject: the IP Address is not accepted. No further verification is required. Verification will halt with typed result {:error, :rejected}. {:dynamic, dynamic_fun}: the IP Address is to be handed to the function which will return a further result. It is used mostly for scenarios where the whitelist / blacklist is maintained and updated dynamically. {:verify_ip, address}: the value resolves to an IP Address which needs to be verified again. This can happen when the IP Address has been identified as an IPv6 address wrapping an IPv4 address (as per Shun.Preset.IPv6.Embedded), so the underlying IPv4 address must be verified next.","ref":"Shun.Provider.html#c:verify_ip/1","title":"Shun.Provider.verify_ip/1","type":"callback"},{"doc":"Provides decision on the parsed URI.For each incoming URI, the following values are accepted: :accept: the URI is is accepted for use. No further verification is required. Verification will halt with typed result {:ok, Shun.uri()}. :reject: the URI is not accepted. No further verification is required. Verification will halt with typed result {:error, :rejected}. :resolve: the URI may be accepted if its underlying A and AAAA records pass validation. {:dynamic, dynamic_fun}: the URI is to be handed to the function which will return a further result. It is used mostly for scenarios where the whitelist / blacklist is maintained and updated dynamically. {:verify_ip, address}: the value resolves to an IP Address which needs to be verified again.","ref":"Shun.Provider.html#c:verify_uri/1","title":"Shun.Provider.verify_uri/1","type":"callback"},{"doc":"","ref":"Shun.Provider.html#t:dynamic_address/0","title":"Shun.Provider.dynamic_address/0","type":"type"},{"doc":"","ref":"Shun.Provider.html#t:dynamic_address_fun/0","title":"Shun.Provider.dynamic_address_fun/0","type":"type"},{"doc":"","ref":"Shun.Provider.html#t:dynamic_uri/0","title":"Shun.Provider.dynamic_uri/0","type":"type"},{"doc":"","ref":"Shun.Provider.html#t:dynamic_uri_fun/0","title":"Shun.Provider.dynamic_uri_fun/0","type":"type"},{"doc":"","ref":"Shun.Provider.html#t:result_address/0","title":"Shun.Provider.result_address/0","type":"type"},{"doc":"","ref":"Shun.Provider.html#t:result_uri/0","title":"Shun.Provider.result_uri/0","type":"type"},{"doc":"Specifies how names are resolved to addresses.The resolved address is used by Shun.Verifier when the callback module has specified that the URI encountered should be resolved.","ref":"Shun.Resolver.html","title":"Shun.Resolver","type":"behaviour"},{"doc":"Resolves the given host name to one or more addresses.","ref":"Shun.Resolver.html#c:resolve/2","title":"Shun.Resolver.resolve/2","type":"callback"},{"doc":"Implements Shun.Resolver using :inet_res.lookup/4.","ref":"Shun.Resolver.InetRes.html","title":"Shun.Resolver.InetRes","type":"module"},{"doc":"","ref":"Shun.Resolver.InetRes.html#resolve/2","title":"Shun.Resolver.InetRes.resolve/2","type":"function"},{"doc":"Represents what should be done based on the target pattern, which can represent an URI, IPv4, or IPv6 address. It can also be given a String literal, which represents either an IPv4 or IPv6 address, or a range of addresses using CIDR notation.Since the Rule module only emits results based on target patterns (i.e. Elixir AST), it is best used from macros, such as those found within Shun.Builder, which can implement macros.","ref":"Shun.Rule.html","title":"Shun.Rule","type":"module"},{"doc":"Generates an Accept rule for the given Target.Expects a target conforming to Shun.Rule.Target.t/0.","ref":"Shun.Rule.html#accept/1","title":"Shun.Rule.accept/1","type":"function"},{"doc":"Generates a Dynamic rule for the given Target.Expects a target conforming to Shun.Rule.Target.t/0.The second argument must refer to a function, which accepts either an URI or an Address.ExampleYou can use handle/2 to implement a Rule which will call your function at runtime if the value was matched.defmodule MyApp.Shun do use Shun.Builder handle %URI{}, &amp;custom_handle_uri/1 def custom_handle_uri(uri) do cond do MyApp.Whitelist.allow_host?(uri.host) -&gt; :accept true -&gt; :reject end end endYou can also use guards with handle/2:defmodule MyApp.Shun do use Shun.Builder handle %URI{host: host} when host == &quot;example.com&quot;, &amp;custom_handle_uri/1 … end","ref":"Shun.Rule.html#handle/2","title":"Shun.Rule.handle/2","type":"function"},{"doc":"Generates a Reject rule for the given Target.Expects a target conforming to Shun.Rule.Target.t/0.","ref":"Shun.Rule.html#reject/1","title":"Shun.Rule.reject/1","type":"function"},{"doc":"Represents a handler function, to be used with handle/2.","ref":"Shun.Rule.html#t:handle_fun/0","title":"Shun.Rule.handle_fun/0","type":"type"},{"doc":"Represents a Rule that is built and can be used at compile-time.Rules are understood by Shun.Builder.","ref":"Shun.Rule.html#t:t/0","title":"Shun.Rule.t/0","type":"opaque"},{"doc":"Encapsulates target classification logic used by Shun.Rule to interpret target patterns.All Rules are built with Targets, which are usually quoted patterns when the relevant generator functions are being used from macros, such as ones in Shun.Builder. These can represent URIs, IPv4 or IPv6 addresses, CIDR blocks, or single IP addresses.Unquoted 4-arity / 8-arity tuples, String literals, and URI structs are also valid. This is to aid creation of Preset modules, which implement Shun.Preset and must return valid lists of Shun.Rule.t/0.The following forms of Targets, for example, are valid:{192, 168, 1, 1}, which represents an IPv4 Address at 192.168.1.1.{10, _, _, _}, which represents an IPv4 Address at 10.x.x.x.{_, _, _, _}, which represents any IPv4 Address.IPv6 addresses, represented as 8-arity tuples, are also valid:{0, 0, 0, 0, 0, 0, 0, 1}, which represents an IPv6 loopback address.{0x8bad, 0xf00d, _, _, _, _, _, _}, which represents another IPv6 address.{_, _, _, _, _, _, _, _}, which represents any IPv6 address.Patterns that match URI structs can also be used as Targets:%URI{scheme: &quot;https&quot;}%URI{scheme: &quot;https&quot;, host: &quot;example.com&quot;, path: &quot;/admin&quot;}%URI{scheme: &quot;https&quot;, host: &quot;example.com&quot;, path: &quot;/books/&quot; &lt;&gt; _}Lastly, Strings that represent IP Addresses or CIDR blocks can be used as Targets:192.168.1.1192.168.100.14/242002::1234:abcd:ffff:c0a8:101/64Strings that are URLs are not accepted; for these purposes you should build URI patterns. This is to ensure that whenever a string literal is used, it represents an IPv4 or IPv6 address, or IPv4 / IPv6 CIDR literal.Alternatively, for example when building a new Preset, you can pass an URI struct as a Target, which will be compiled down to a pattern that matches the non-nil keys of that URI struct.Specifically:iex(1)&gt; lhs = Shun.Rule.reject(%URI{host: &quot;169.254.169.254&quot;}).pattern iex(2)&gt; {:%, [], [{:__aliases__, _, [:URI]}, {:%{}, [], [host: &quot;169.254.169.254&quot;]}]} = lhs iex(1)&gt; rhs = quote do: %URI{host: &quot;169.254.169.254&quot;} iex(2)&gt; {:%, [], [{:__aliases__, _, [:URI]}, {:%{}, [], [host: &quot;169.254.169.254&quot;]}]} = rhsGuardsWhen the Rule is given a Target in the form of an Elixir pattern, guards can be used.For Rules based on URIs, this is a great way to enforce hosts or schemes; for Rules based on IPv4 or IPv6 patterns, this is an alternative to specifying CIDR ranges.The following Target forms with guard clauses, for example, are valid:{a, _, _, _} when a == 10{a, b, _, _} when a &lt; b{a, b, _, _} when (a * (b + c)) &gt; 10{a, _, _, _, _, _, _, _} when a &gt;= 0xfe80 and a &lt;= 0xfebf%URI{host: &quot;example.com&quot;, path: &quot;/books/&quot; &lt;&gt; _} when scheme != &quot;ftp&quot;","ref":"Shun.Rule.Target.html","title":"Shun.Rule.Target","type":"module"},{"doc":"","ref":"Shun.Rule.Target.html#classify/1","title":"Shun.Rule.Target.classify/1","type":"function"},{"doc":"Represents an AST fragment to be reintegrated as guard.","ref":"Shun.Rule.Target.html#t:guard/0","title":"Shun.Rule.Target.guard/0","type":"type"},{"doc":"Represents an AST fragment to be reintegrated as match pattern.","ref":"Shun.Rule.Target.html#t:pattern/0","title":"Shun.Rule.Target.pattern/0","type":"type"},{"doc":"","ref":"Shun.Rule.Target.html#t:result/0","title":"Shun.Rule.Target.result/0","type":"type"},{"doc":"Represents a Target which can be used with one of the functions that builds a Rule.","ref":"Shun.Rule.Target.html#t:t/0","title":"Shun.Rule.Target.t/0","type":"type"},{"doc":"Allows verification of an URI, IPv4 address, or IPv6 address using a Provider.","ref":"Shun.Verifier.html","title":"Shun.Verifier","type":"module"},{"doc":"Performs verification of the value using the Provider module provided.In case of Strings being used, it will first be parsed as an URI and validated as URI.","ref":"Shun.Verifier.html#perform/3","title":"Shun.Verifier.perform/3","type":"function"},{"doc":"Allows customisation of how verification is handled.At this time the only change allowed is related to resolution of hostnames in URIs. The default resolver is Shun.Resolver.InetRes which wraps :inet_res.lookup/4, but any other module that implements the behaviour Shun.Resolver can be used.","ref":"Shun.Verifier.html#t:option/0","title":"Shun.Verifier.option/0","type":"type"},{"doc":"Represents the Provider module, which implements the Shun.Provider behaviour.","ref":"Shun.Verifier.html#t:provider/0","title":"Shun.Verifier.provider/0","type":"type"},{"doc":"Represents the result of URI / IPv4 / IPv6 verification.In most cases, a pattern-match against {:ok, _} is adequate. In case of URIs that have had their host names resolved for further verification, the underlying IPs will be returned in a list.","ref":"Shun.Verifier.html#t:result/0","title":"Shun.Verifier.result/0","type":"type"},{"doc":"Represents the value to be validated, which is either an URI struct, a String, or an IP address represented as a 4-arity or 8-arity tuple.","ref":"Shun.Verifier.html#t:value/0","title":"Shun.Verifier.value/0","type":"type"},{"doc":"Represents a compile-time error when the Preset module has not provided a default handler, yet is referred to with Shun.Builder.handle/1.","ref":"Shun.Preset.DefaultHandlerError.html","title":"Shun.Preset.DefaultHandlerError","type":"exception"},{"doc":"Represents a compile-time error when the pattern used to build a Rule is not valid.","ref":"Shun.Rule.MalformedError.html","title":"Shun.Rule.MalformedError","type":"exception"},{"doc":"ShunThe Shun library provides URI, IPv4 and IPv6 address verification primitives for Elixir applications. It is useful for Web applications that act on behalf of the customer, e.g. resource pipelines which operate on user-provided URIs.","ref":"readme.html","title":"Shun","type":"extras"},{"doc":"The Shun library provides a way to easily add domain / address verification to your application. It operates based on a set of Rules that are compiled into your custom module, but you are also able to inject function references where needed, to affect the decisions dynamically.Within the DSL, each Rule must have a Target. Additionaly, guards and handlers are optionally available. There are three types of Rules: Accept, Reject and Handle. The first two kinds are self-explanatory; the third kind allows you to specify a function reference, so your application can dynamically decide what to do with a Target. There are also three types of Targets: URI structs, :inet tuples (4-arity for IPv4 or 8-arity for IPv8), or CIDR Notations. For Rules using URI structs or tuples, pattern-matching via use of guards is available. For all kinds of Targets, the Handle Rule type allows associating a remote function reference, which allows your Application to dynamically decide what to do with a particular URI or IP Address.","ref":"readme.html#capabilities","title":"Shun - Capabilities","type":"extras"},{"doc":"To install Shun, add the following line in your application’s dependencies:defp deps do [ {:shun, &quot;~&gt; 1.0.1&quot;} ] end","ref":"readme.html#installation","title":"Shun - Installation","type":"extras"},{"doc":"The usual way to use Shun.Builder is by installing it in a custom module.defmodule MyApp.Shun do use Shun.Builder handle Shun.Preset.IPv6.Embedded reject Shun.Preset.AWS.InstanceMetadata endAdditional Rules can be added using a simple DSL (provided by Shun.Rule):defmodule MyApp.Shun do use Shun.Builder handle Shun.Preset.IPv6.Embedded reject Shun.Preset.AWS.InstanceMetadata reject &quot;10.0.0.0/8&quot; reject %URI{scheme: scheme} when scheme != &quot;https&quot; endAfterwards, you can call Shun.verify/2, for example:Shun.verify(MyApp.Shun, &quot;http://google.com&quot;)","ref":"readme.html#usage","title":"Shun - Usage","type":"extras"},{"doc":"The following presets are bundled with Shun:Shun.Preset.IPv4.LinkLocalShun.Preset.IPv4.LoopbackShun.Preset.IPv4.PrivateShun.Preset.IPv6.EmbeddedShun.Preset.IPv6.LinkLocalShun.Preset.IPv6.LoopbackShun.Preset.AWS.InstanceMetadataThese Presets provide reject rules that can be plugged into your own Shun provider.You can use presets with the accept, reject or handle macros, for example:reject Shun.Preset.IPv4.LinkLocal # rejects link-local ipv4 addresses reject Shun.Preset.AWS.InstanceMetadata # rejects 169.254.169.254 handle Shun.Preset.IPv6.Embedded # handles underlying IPv4 reject Shun.Preset.IPv6.Embedded # rejects all embedded IPv4","ref":"readme.html#presets","title":"Shun - Presets","type":"extras"},{"doc":"To accept URLs as long as they do not resolve to undesired IPs:defmodule MyApp.Shun do use Shun.Builder # reject &lt;preset&gt; accept {_, _, _, _} accept {_, _, _, _, _, _, _, _} # Note that a default action for URIs is not provided - this forces all # URIs to be resolved, so IP rules in presets are exercised endTo only accept a few specific URIs:defmodule MyApp.Shun do use Shun.Builder accept %URI{host: &quot;example.com&quot;} accept %URI{host: &quot;special.example.com&quot;} reject %URI{} reject {_, _, _, _} reject {_, _, _, _, _, _, _, _} endTo use a function to decide what to do with the URI:defmodule MyApp.Shun do use Shun.Builder reject %URI{scheme: scheme} when scheme != &quot;https&quot; handle %URI{}, &amp;handle_uri/1 defp handle_uri(uri) do cond do uri.host == &quot;dynamic.example.com&quot; -&gt; :reject true -&gt; :accept end end endTo only allow URIs from a specific AWS S3 bucket (in virtual hosted-style):defmodule MyApp.Shun do use Shun.Builder reject %URI{scheme: scheme} when scheme != &quot;https&quot; handle %URI{}, &amp;handle_uri/1 defp handle_uri(%{host: host}) do bucket_name = System.get_env(&quot;AWS_BUCKET_NAME&quot;) region_name = System.get_env(&quot;AWS_REGION&quot;) names = [ &quot;\#{bucket_name}.s3-accelerate.dualstack.amazonaws.com&quot;, &quot;\#{bucket_name}.s3-accelerate.amazonaws.com&quot;, &quot;\#{bucket_name}.s3.dualstack.\#{region_name}.amazonaws.com&quot;, &quot;\#{bucket-name}.s3.\#{region_name}.amazonaws.com&quot;, &quot;\#{bucket-name}.s3.amazonaws.com&quot; ] cond do Enum.member?(names, host) -&gt; :accept true -&gt; :reject end end end","ref":"readme.html#scenarios","title":"Shun - Scenarios","type":"extras"},{"doc":"Please see documentation in Shun.Builder regarding the order of rules and default actions. The default actions are as follows:IPs are rejectedURIs that have IPs as host are processed as if they were IPsOther URIs are resolved and are only accepted if all underlying IPs are accepted If a catch-all rule is specifically provided, then the default action for that target type will not be generated. Any Provider module that implements the Shun.Provider behaviour can be used. The DSL as implemented by Shun.Rule emits Rules on a per-entry basis. However, it is most likely that you will use Shun.Builder so Rules are compiled to function heads ahead of time. Shun.Builder does not reorder Rules, so they are evaluated in the original order. If your application follows redirections, it would be wise to re-validate the URI or IP address on each redirection with Shun.","ref":"readme.html#notes","title":"Shun - Notes","type":"extras"},{"doc":"During design and prototype development of this library, the Author has drawn inspiration from the following implementations, and therefore thanks all contributors for their generosity:c-rack/cidr-elixircobenian/inet_cidrThe author wishes to additionally thank the following individuals for their input during the implemention process:Alvise SusmelDerek KraanBryan Hunt","ref":"readme.html#acknowledgements","title":"Shun - Acknowledgements","type":"extras"}]